/*	sms - application for sending, receiving and management of short message
 *
 *	Authors: YIN Huasong, WU Yu <yu.wu@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <gtk/gtk.h>
#include <gpe/gpeskwindow.h>
#include <gdk/gdkkeysyms.h>
/* gpe includes */
#include <gpe/init.h>           /* gpe_application_init */
#include <gpe/pixmaps.h>        /* gpe_load_icons */
#include <gpe/spacing.h>        /* gpe_get_border, gpe_get_boxspacing */


#include <sys/stat.h>
#include <time.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <glib.h>

#include <message.h>
#include <pim.h>
#include <iac.h>


#include "callbacks.h"
#include "sms-iac.h"
#include "sms-app.h"


extern msg_sms_create_text_view_t textview;
extern msg_sms_tree_col_t tree_col;
extern msg_sms_test_t msgtest;
extern msg_sms_flag_t sms_flag;
extern msg_sms_tree_view_t sms_treeview;
extern msg_sms_tree_view_path_t sms_path;


GHashTable *hashtable;          /* save every window's handle */
gint array[10];                 /* use in hashtable */
gint count;                     /* use in hashtable */

gint time_out_id;               /* timer */
msg_sid_t sid;                  /* session id */
gint service_start;             /* init service */ 

extern GtkUIManager *ui_manager;

extern GList *contact_from_addrbook;
extern gint pre_list_count;

extern gint pre_list_count;

extern GMainLoop *loop;         /* session */

static gboolean search_name_from_sim (gint index, const gchar *num,
                                      gchar **name_b, gchar **photo_path_b,
                                      gchar **Ringtone_path_b);
                                      
static gboolean search_from_ab (const gchar *num, gchar **name_b,
                                gchar **photo_path_b,
                                gchar **Ringtone_path_b);

/* read the rc file */
gboolean
file_exists (const char *filename)
{
  struct stat statbuf;

  return stat (filename, &statbuf) == 0;
}

/* the function about checkbox */
void
actived_renderer_toggle (GtkCellRendererToggle *renderer,
                         gchar *path, GtkTreeView *tree_view)
{
  gboolean active;
  gint check_msgid;
  gint i;
  GtkTreeModel *model;
  GtkTreeIter iter;
  GtkTreeIter first_iter;

  model = gtk_tree_view_get_model (tree_view);

  gtk_tree_model_get_iter_from_string (model, &iter, path);
  gtk_tree_model_get_iter_first (model, &first_iter);

  if (strcmp (path, "0") == 0)
  {
    gtk_tree_model_get (model, &iter, COLUMN_CHECK_BUTTON, &active, -1);

    if (msgtest.garray->len > 0)
      msgtest.garray =
        g_array_remove_range (msgtest.garray, 0, msgtest.garray->len);

    if (!active)
    {
      while (gtk_tree_model_iter_next (model, &iter))
      {
        gtk_tree_model_get (model, &iter, COLUMN_ID, &check_msgid, -1);

        g_array_append_val (msgtest.garray, check_msgid);

        gtk_list_store_set (GTK_LIST_STORE (model), &iter, COLUMN_CHECK_BUTTON,
                            !active, -1);

      }

      g_print
        ("********************************array size:%d & sms number:%d\n",
         msgtest.garray->len, sms_path.sms_number);
    }
    else
    {
      while (gtk_tree_model_iter_next (model, &iter))
        gtk_list_store_set (GTK_LIST_STORE (model), &iter, COLUMN_CHECK_BUTTON,
                            !active, -1);

      g_print ("********************************array size000:%d\n",
               msgtest.garray->len);
    }
    active = !active;
    gtk_list_store_set (GTK_LIST_STORE (model), &first_iter,
                        COLUMN_CHECK_BUTTON, active, -1);
  }
  else
  {
    gtk_tree_model_get (model, &iter, COLUMN_CHECK_BUTTON, &active,
                        COLUMN_ID, &check_msgid, -1);
    if (!active)
    {
      g_array_append_val (msgtest.garray, check_msgid);
    }
    else
    {
      for (i = 0; i < msgtest.garray->len; i++)
      {
        if (check_msgid == g_array_index (msgtest.garray, gint, i))
          msgtest.garray = g_array_remove_index (msgtest.garray, i);
      }
    }

    g_print ("********************************array size not first row:%d\n",
             msgtest.garray->len);

    if (msgtest.garray->len >= sms_path.sms_number)
      gtk_list_store_set (GTK_LIST_STORE (model), &first_iter,
                          COLUMN_CHECK_BUTTON, TRUE, -1);
    else
      gtk_list_store_set (GTK_LIST_STORE (model), &first_iter,
                          COLUMN_CHECK_BUTTON, FALSE, -1);

    active = !active;
    gtk_list_store_set (GTK_LIST_STORE (model), &iter, COLUMN_CHECK_BUTTON,
                        active, -1);
  }
}

/* the function about checkbox */
void
changed_renderer_pixbuf (GtkCellRendererToggle *renderer,
                         gchar *path, GtkTreeView *tree_view)
{
  GtkTreeModel *model;
  GtkTreeIter iter;

  model = gtk_tree_view_get_model (tree_view);
  gtk_tree_model_get_iter_from_string (model, &iter, path);

  gtk_list_store_set (GTK_LIST_STORE (model), &iter, COLUMN_ICON,
                      get_icon ("msg_icon_read.png"), -1);
}

/* create scrolled_window */
GtkWidget *
make_swindow (GtkWidget *vbox)
{
  GtkWidget *sw = NULL;

  sw = gtk_scrolled_window_new (NULL, NULL);

  gtk_box_pack_start (GTK_BOX (vbox), sw, TRUE, TRUE, 0);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (sw),
                                       GTK_SHADOW_ETCHED_IN);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw),
                                  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  return sw;
}

GdkPixbuf *
get_icon (gchar *image_name)
{
  GdkPixbuf *icon = NULL;
  GError *error = NULL;
  gchar *file_path = NULL;

  file_path = g_strdup_printf ("%s/%s/%s", PREFIX, IMAGEPATH, image_name);
  icon = gdk_pixbuf_new_from_file (file_path, &error);
  g_free (file_path);
  return icon;
}


GtkWidget *
xpm_label_box_v (gchar *xpm_name, gchar *label_text)
{
  GtkWidget *box;
  GtkWidget *label;
  GtkWidget *image;
  gchar *file_path = NULL;

  /* create a box for the image and label */
  box = gtk_vbox_new (FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (box), 2);

  /* create a image */
  file_path = g_strdup_printf ("%s/%s/%s", PREFIX, IMAGEPATH, xpm_name);
  image = gtk_image_new_from_file (file_path);
  g_free (file_path);

  /* create a label for the button */
  label = gtk_label_new (label_text);
  gtk_widget_set_name (label, "check_label");

  /* the image and the label are assembled in the box */
  gtk_box_pack_start (GTK_BOX (box), label, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (box), image, FALSE, FALSE, 0);
  return box;
}

/* create a new a hbox which includes a image and a label, then return the hbox */
GtkWidget *
xpm_label_box (gchar *xpm_name, gchar *label_text)
{
  GtkWidget *box;
  GtkWidget *label;
  GtkWidget *image;
  gchar *file_path = NULL;

  /* create a box for the image and label */
  box = gtk_hbox_new (FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (box), 2);

  /* create a image */
  file_path = g_strdup_printf ("%s/%s/%s", PREFIX, IMAGEPATH, xpm_name);
  image = gtk_image_new_from_file (file_path);
  g_free (file_path);

  /* create a label for the button */
  label = gtk_label_new (label_text);
  gtk_widget_set_name (label, "check_label");

  /* the image and the label are assembled in the box */
  gtk_box_pack_start (GTK_BOX (box), image, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (box), label, TRUE, FALSE, 0);

  return box;
}

/* create event_box */
GtkWidget *
create_event_box (GtkWidget *vbox, gchar *xpm_name, gchar *label_text)
{
  GtkWidget *hbox;
  GtkWidget *image;
  GtkWidget *label;
  GtkWidget *eventbox;
  gchar *file_path = NULL;

  eventbox = gtk_event_box_new ();
  gtk_box_pack_start (GTK_BOX (vbox), eventbox, FALSE, TRUE, 0);
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (eventbox), hbox);

  label = gtk_label_new (label_text);
  file_path = g_strdup_printf ("%s/%s/%s", PREFIX, IMAGEPATH, xpm_name);
  image = gtk_image_new_from_file (file_path);
  gtk_box_pack_start (GTK_BOX (hbox), image, FALSE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);

  g_free (file_path);

  return eventbox;
}


void
create_menu_actions (void)
{
  GList *actionGroup;
  GList *actions;

  actionGroup = gtk_ui_manager_get_action_groups (ui_manager);
  actions =
    gtk_action_group_list_actions (GTK_ACTION_GROUP (actionGroup->data));

  guint i = 0, length;

  length = g_list_length (actions);
  while (i < length)
  {
    g_object_set (GTK_ACTION (actions->data), "visible", TRUE, NULL);
    actions = actions->next;
    i++;
  }
}

void
set_action_property (GtkAction *action, gchar *menu_action_text,
                     gboolean action_flag)
{
  action = gtk_ui_manager_get_action (ui_manager, menu_action_text);
  g_object_set (action, "visible", action_flag, NULL);
}

/* add folders or sms to tree_view */
void
list_store_append (GtkListStore *store, GtkWidget *check_button,
                   GdkPixbuf *icon, gint id, gchar *name)
{
  GtkTreeIter iter;

  gtk_list_store_append (GTK_LIST_STORE (store), &iter);
  gtk_list_store_set (GTK_LIST_STORE (store), &iter,
                      COLUMN_CHECK_BUTTON, check_button,
                      COLUMN_ICON, icon, COLUMN_ID, id, COLUMN_TEXT, name, -1);
}


/* create the column */
GtkTreeViewColumn *
create_col (GtkCellRenderer *renderer, gchar *rendererType, guint col_num)
{
  GtkTreeViewColumn *col;

  col = gtk_tree_view_column_new ();
  gtk_tree_view_column_pack_start (col, GTK_CELL_RENDERER (renderer), FALSE);
  gtk_tree_view_column_set_attributes (col, GTK_CELL_RENDERER (renderer),
                                       rendererType, col_num, NULL);

  return col;
}

/* create tree_view */
GtkWidget *
create_tree_view (GtkListStore *store)
{
  GtkWidget *tree_view;
  GtkTreeModel *model;
  GtkTreeViewColumn *col;
  GtkCellRenderer *renderer;

  model = GTK_TREE_MODEL (store);
  tree_view = gtk_tree_view_new_with_model (model);

  g_signal_connect (G_OBJECT (tree_view), "key-press-event",
                    G_CALLBACK (tree_view_key_press_handler), NULL);

  gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (tree_view), FALSE);
  gtk_tree_view_set_enable_search (GTK_TREE_VIEW (tree_view), FALSE);
  gtk_widget_grab_focus (tree_view);
  renderer = gtk_cell_renderer_toggle_new ();
  col = create_col (renderer, "active", COLUMN_CHECK_BUTTON);
  gtk_tree_view_column_set_visible (col, sms_flag.multi_select_flag);
  gtk_tree_view_append_column (GTK_TREE_VIEW (tree_view), col);
  g_signal_connect (G_OBJECT (renderer), "toggled",
                    G_CALLBACK (actived_renderer_toggle), tree_view);

  renderer = gtk_cell_renderer_pixbuf_new ();
  col = create_col (GTK_CELL_RENDERER (renderer), "pixbuf", COLUMN_ICON);
  gtk_tree_view_column_set_min_width (col, 40);
  gtk_tree_view_append_column (GTK_TREE_VIEW (tree_view), col);

  renderer = gtk_cell_renderer_text_new ();
  col = create_col (renderer, "text", COLUMN_ID);
  gtk_tree_view_column_set_visible (col, FALSE);
  gtk_tree_view_append_column (GTK_TREE_VIEW (tree_view), col);

  renderer = gtk_cell_renderer_text_new ();
  col = create_col (renderer, "text", COLUMN_TEXT);
  gtk_tree_view_append_column (GTK_TREE_VIEW (tree_view), col);

  g_object_unref (model);

  return tree_view;
}

/* the function about selection row of tree_view,get the msg_id or folder_id */
gboolean
view_msg_selection_func (GtkTreeSelection *selection, GtkTreeModel *model,
                         GtkTreePath *path, 
                         gboolean path_currently_selected,
                         gpointer userdata)
{
  GtkTreeIter iter;
  gint fid;

  if (gtk_tree_model_get_iter (model, &iter, path))
  {
    gtk_tree_model_get (model, &iter, COLUMN_ID, &fid, -1);
    msgtest.root_fid = fid;
  }
  return TRUE;                  /* allow selection state to change */
}

/* the function about selection row of tree_view,get the msg_id or folder_id */
gboolean
view_folder_selection_func (GtkTreeSelection *selection, GtkTreeModel *model,
                            GtkTreePath *path,
                            gboolean path_currently_selected,
                            gpointer userdata)
{
  GtkTreeIter iter;
  gint fid;

  if (gtk_tree_model_get_iter (model, &iter, path))
  {
    gtk_tree_model_get (model, &iter, COLUMN_ID, &fid, -1);
    msgtest.fid = fid;
    sms_path.folder_path = gtk_tree_path_to_string (path);
  }
  return TRUE;                  /* allow selection state to change */
}

/* the function about selection row of tree_view,get the msg_id or folder_id */
gboolean
view_sms_selection_func (GtkTreeSelection *selection,
                         GtkTreeModel *model,
                         GtkTreePath *path,
                         gboolean path_currently_selected, gpointer userdata)
{
  GtkTreeIter iter;
  gint msgid;

  if (gtk_tree_model_get_iter (model, &iter, path))
  {

    gtk_tree_model_get (model, &iter, COLUMN_ID, &msgid, -1);

    msgtest.msgid = msgid;

    sms_path.sms_list_path = gtk_tree_path_to_string (path);

  }
  return TRUE;                  /* allow selection state to change */
}

gboolean
contact_changed (GtkTextView *textview, GdkEventKey *event,
                 GtkWidget *textview_content)
{
  GtkTextBuffer *buffer;
  GtkTextIter iter;
  GtkTextMark *cursor;

  buffer = gtk_text_view_get_buffer (textview);
  
  /* Get the mark at cursor. */
  cursor = gtk_text_buffer_get_mark (buffer, "insert");
  
  /* Get the iter at cursor. */
  gtk_text_buffer_get_iter_at_mark (buffer, &iter, GTK_TEXT_MARK (cursor));

  if (event->keyval == GDK_Down)
  {
    gtk_widget_grab_focus (textview_content);
    return TRUE;
  }

  if (event->keyval == GDK_Return)
    return TRUE;

  if ((gtk_text_iter_get_offset (&iter) <= 3
         && (event->keyval == GDK_BackSpace || event->keyval == GDK_Left))
       || event->keyval == GDK_Up)
    return TRUE;
  else
    return FALSE;
}

gboolean
content_changed (GtkTextView *textview, GdkEventKey *event,
                 GtkWidget *textview_contact)
{
  GtkTextBuffer *buffer;

  buffer = gtk_text_view_get_buffer (textview);
  GtkTextIter iter;

  gtk_text_buffer_get_iter_at_mark (buffer, &iter,
                                    gtk_text_buffer_get_insert (buffer));
  if (gtk_text_iter_get_line (&iter) == 0 && event->keyval == GDK_Up)
  {
    gtk_widget_grab_focus (textview_contact);
    return TRUE;
  }
  else
    return FALSE;
}

/* Check which softkeys are available and set up the initial labels. */
gboolean
setup_softkeys (GtkWidget *window, gchar *menu_left_str,
                gchar *menu_right_str)
{
  gint num_softkeys = gpe_skwindow_get_softkey_count (GPE_SKWINDOW (window));

  if (num_softkeys == SK_MAX)
  {
    gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), SK_LEFT,
                                    menu_left_str);
    gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), SK_RIGHT,
                                    menu_right_str);
    return TRUE;
  }
  return FALSE;
}

gboolean
destroy_window (GtkWidget *widget, gint key_number, gpointer data)
{
  gtk_widget_destroy (widget);

  return FALSE;
}

void
get_folders (GtkListStore *store)
{
  gint msg_new = 0;

  tree_col.icon = get_icon ("icon_create.png");
  tree_col.id = MSG_SMS_CREATE;
  strcpy (tree_col.name, "Create");
  list_store_append (store, NULL, tree_col.icon, tree_col.id, tree_col.name);

  msg_new =
    msg_folder_count_msgs (sid, MSG_FOLDER_INBOX, MSG_RECEIVED_UNREAD, 1);

  g_print ("msg_new is %d\n", msg_new);

  if (msg_new)
  {
    tree_col.icon = get_icon ("icon_new_msg.png");
    tree_col.id = MSG_FOLDER_INBOX;
    sprintf (tree_col.name, "Inbox (%d new)", msg_new);
  }
  else if (msg_new == 0)
  {
    tree_col.icon = get_icon ("icon_no_new_msg.png");
    tree_col.id = MSG_FOLDER_INBOX;
    strcpy (tree_col.name, "Inbox");
  }
  list_store_append (store, NULL, tree_col.icon, tree_col.id, tree_col.name);

  tree_col.icon = get_icon ("icon_sent.png");
  tree_col.id = MSG_FOLDER_SENT;
  strcpy (tree_col.name, "Sent");
  list_store_append (store, NULL, tree_col.icon, tree_col.id, tree_col.name);

  tree_col.icon = get_icon ("icon_outbox.png");
  tree_col.id = MSG_FOLDER_OUTBOX;
  strcpy (tree_col.name, "Outbox");
  list_store_append (store, NULL, tree_col.icon, tree_col.id, tree_col.name);

  tree_col.icon = get_icon ("icon_draft.png");
  tree_col.id = MSG_FOLDER_DRAFT;
  strcpy (tree_col.name, "Draft");
  list_store_append (store, NULL, tree_col.icon, tree_col.id, tree_col.name);

  tree_col.icon = get_icon ("icon_reports.png");
  tree_col.id = MSG_FOLDER_REPORT;
  strcpy (tree_col.name, "Report");
  list_store_append (store, NULL, tree_col.icon, tree_col.id, tree_col.name);

  tree_col.icon = get_icon ("icon_recycle.png");
  tree_col.id = MSG_FOLDER_TRASH;
  strcpy (tree_col.name, "Trash");
  list_store_append (store, NULL, tree_col.icon, tree_col.id, tree_col.name);

  tree_col.icon = get_icon ("icon_template.png");
  tree_col.id = MSG_FOLDER_TEMPLATE;
  strcpy (tree_col.name, "Template");
  list_store_append (store, NULL, tree_col.icon, tree_col.id, tree_col.name);

  tree_col.icon = get_icon ("setting.png");
  tree_col.id = MSG_SMS_SETTING;
  strcpy (tree_col.name, "Setting");
  list_store_append (store, NULL, tree_col.icon, tree_col.id, tree_col.name);

}

gboolean
get_smses_from_folder (GtkListStore *store, gint fid)
{
  gint j;
  msg_message_t **msg_a = NULL;
  uint32_t number = 0;
  gint size = 0;
  const gchar *contact = NULL;
  gchar *name = NULL;
  gchar *body = NULL;

  if (time_out_id)
    g_source_remove (time_out_id);

  fid = msgtest.fid;

  msg_folder_list_msg_dig (sid, fid, &number, &msg_a);

  sms_path.sms_number = number;

  g_print ("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$Get the sms list!\n");

  if (sms_flag.multi_select_flag)
  {
    strcpy (tree_col.name, "Select All");
    tree_col.id = 0;
    list_store_append (store, NULL, NULL, tree_col.id, tree_col.name);
  }
  if (sms_flag.sort_date_flag)
  {
    gint k;
    msg_message_t *msg_temp = NULL;

    for (j = 0; j < number; j++)
    {
      for (k = j + 1; k < number; k++)
      {
        if (msg_get_timestamp (sid, msg_a[j])
            < msg_get_timestamp (sid, msg_a[k]))
        {
          msg_temp = msg_a[j];
          msg_a[j] = msg_a[k];
          msg_a[k] = msg_temp;
        }
      }
    }
  }

  for (j = number - 1; j >= 0; j--)
  {
    tree_col.id = msg_get_id (sid, msg_a[j]);
    if (fid == MSG_FOLDER_INBOX)
      contact = msg_get_from (sid, msg_a[j]);
    else
      contact = msg_get_recipientlist (sid, msg_a[j]);

    if (search_from_addressbook (0, contact, &name, NULL))
    {
      if (name)
      {
        contact = name;
      }
    }
    body = msg_get_body_by_id (sid, msg_get_id (sid, msg_a[j]), &size);
    strcpy (tree_col.name, contact);
    strcat (tree_col.name, "\n");
    strncat (tree_col.name, body, 28);

    get_icon_by_status (&tree_col.icon, msg_get_status (sid, msg_a[j]));

    list_store_append (store, NULL, tree_col.icon, tree_col.id, tree_col.name);
    g_free (body);
    g_free (name);
  }

  for (j = 0; j < number; j++)
  {
    msg_release (sid, msg_a[j]);
  }
  g_free (msg_a);

  sms_flag.open_flag = TRUE;

  return FALSE;
}

void
set_tree_view_cursor (GtkTreeView *treeview, gchar *path_str)
{
  GtkTreePath *path;

  path = gtk_tree_path_new_from_string (path_str);
  gtk_tree_view_set_cursor (GTK_TREE_VIEW (treeview), path, NULL, FALSE);
}

void
refresh_smses_from_folder (GtkListStore *store, gint fid)
{
  gtk_list_store_clear (store);
  get_smses_from_folder (store, fid);
}

GtkWidget *
create_pop_window (gchar *pix_name, gchar *text)
{
  GtkWidget *window;
  GtkWidget *box;
  GtkWidget *frame;

  window = gpe_skwindow_new ();
  gtk_window_set_type_hint (GTK_WINDOW (window), GDK_WINDOW_TYPE_HINT_DIALOG);
  gtk_window_set_default_size (GTK_WINDOW (window), 240, 60);
  gtk_window_set_decorated (GTK_WINDOW (window), FALSE);

  frame = gtk_frame_new (NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_OUT);

  box = xpm_label_box (pix_name, text);
  gtk_container_add (GTK_CONTAINER (frame), box);

  gtk_container_add (GTK_CONTAINER (window), frame);
  gtk_window_move (GTK_WINDOW (window), 0, 240);

  gtk_window_set_modal (GTK_WINDOW (window), TRUE);

  return window;
}


GtkWidget *
create_waiting_window (gchar *pix_name, gchar *text)
{
  GtkWidget *window;
  GtkWidget *box;
  GtkWidget *frame;

  window = gpe_skwindow_new ();
  gtk_window_set_type_hint (GTK_WINDOW (window), GDK_WINDOW_TYPE_HINT_DIALOG);
  gtk_window_set_default_size (GTK_WINDOW (window), 240, 60);
  gtk_window_set_decorated (GTK_WINDOW (window), FALSE);

  frame = gtk_frame_new (NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_OUT);

  box = xpm_label_box_v (pix_name, text);
  gtk_container_add (GTK_CONTAINER (frame), box);

  gtk_container_add (GTK_CONTAINER (window), frame);

  gtk_window_move (GTK_WINDOW (window), 0, 240);

  gtk_window_set_modal (GTK_WINDOW (window), TRUE);

  return window;
}

gboolean
popup_key_press_handler (GtkWidget *widget, GdkEventKey *event,
                         gpointer user_data)
{
  GtkWidget *window;

  window = get_current_window ();

  if (event->keyval == GDK_F4 || event->keyval == GDK_KP_F4)
  {
    gtk_menu_popdown (GTK_MENU (widget));
    gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), SK_LEFT, "Options");
    return TRUE;
  }

  if (event->keyval == GDK_F3 || event->keyval == GDK_KP_F3)
  {
    g_signal_emit_by_name (widget, "activate-current");
    return TRUE;
  }

  return FALSE;
}

gboolean
tree_view_key_press_handler (GtkWidget *widget, GdkEventKey *event,
                             gpointer user_data)
{
  GtkTreePath *path = NULL;
  GtkTreePath *temp_path = NULL;
  GtkTreeModel *model = NULL;
  GtkTreeViewColumn *col = NULL;
  gint result;

  model = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));
  gtk_tree_view_get_cursor (GTK_TREE_VIEW (widget), &path, &col);

  if (event->keyval == GDK_Up || event->keyval == GDK_KP_Up)
  {
    temp_path = gtk_tree_path_new_first ();
    result = gtk_tree_path_compare (path, temp_path);
    gtk_tree_path_free (temp_path);
    temp_path = NULL;

    if (result == 0)
    {
      GtkTreeIter iter;

      if (gtk_tree_model_iter_nth_child
          (model, &iter, NULL,
           gtk_tree_model_iter_n_children (model, NULL) - 1))
        temp_path = gtk_tree_model_get_path (model, &iter);

      gtk_tree_view_set_cursor (GTK_TREE_VIEW (widget), temp_path, NULL, FALSE);

      gtk_tree_path_free (temp_path);

      return TRUE;
    }

    return FALSE;
  }
  if (event->keyval == GDK_Down || event->keyval == GDK_KP_Down)
  {
    GtkTreeIter iter;

    if (gtk_tree_model_iter_nth_child
        (model, &iter, NULL, gtk_tree_model_iter_n_children (model, NULL) - 1))
      temp_path = gtk_tree_model_get_path (model, &iter);

    result = gtk_tree_path_compare (path, temp_path);
    gtk_tree_path_free (temp_path);
    temp_path = NULL;

    if (result == 0)
    {
      temp_path = gtk_tree_path_new_first ();

      gtk_tree_view_set_cursor (GTK_TREE_VIEW (widget), temp_path, NULL, FALSE);

      gtk_tree_path_free (temp_path);

      return TRUE;
    }
    return FALSE;
  }

  return FALSE;
}

gboolean
menu_left_change_to_phonebook (GtkWidget *widget, GdkEventFocus *event,
                               gpointer user_data)
{
  GtkWidget *window;

  window = get_current_window ();

  menus_create (window, "", "");
  gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), SK_LEFT, "PhoneBook");
  return FALSE;
}

void
popup_mapping_handler (GtkWidget *widget, gpointer user_data)
{
  GtkWidget *window;

  window = get_current_window ();
  gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), SK_RIGHT, "Back");
}

gboolean
choose_msg_with_OK (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
  if (event->keyval == GDK_F3 || event->keyval == GDK_KP_F3)
  {
    g_signal_emit_by_name (widget, "activate-current");
    return TRUE;
  }
  else
    return FALSE;
}

/*
 * This creates the toolbar, it is not essential to have this code in a 
 * separate function, but it makes the code easier to read.
 * Together with the toolbar the softkey popup menus are created.
 */
void
menus_create (GtkWidget *window, gchar *menu_left, gchar *menu_right)
{

  GtkWidget *pop_menu_left;
  GtkWidget *pop_menu_right;

  /* While we have constructed the UI manager we can create the menus as well. */
  pop_menu_left = gtk_ui_manager_get_widget (ui_manager, menu_left);
  g_signal_connect (G_OBJECT (pop_menu_left),
                    "key-press-event", G_CALLBACK (popup_key_press_handler),
                    NULL);
  g_signal_connect (G_OBJECT (pop_menu_left), "unmap",
                    G_CALLBACK (popup_mapping_handler), NULL);

  pop_menu_right = gtk_ui_manager_get_widget (ui_manager, menu_right);

  gpe_skwindow_set_softkey_menu (GPE_SKWINDOW (window), SK_LEFT, pop_menu_left);
  gpe_skwindow_set_softkey_menu (GPE_SKWINDOW (window), SK_RIGHT,
                                 pop_menu_right);

}

gboolean
menu_left_change_to_options (GtkWidget *widget, GdkEventFocus *event,
                             gpointer user_data)
{

  GtkWidget *window;
  window = get_current_window ();
  menus_create (window, "/popupCreateOptions-left", "");
  gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), SK_LEFT, "Options");

  return FALSE;
}

void
set_sw_scroll_bar_property (GtkWidget *sw, GtkWidget *widget)
{
  gtk_container_add (GTK_CONTAINER (sw), widget);
  gtk_tree_view_set_hadjustment (GTK_TREE_VIEW (widget),
                                 gtk_scrolled_window_get_hadjustment
                                 (GTK_SCROLLED_WINDOW (sw)));
  gtk_tree_view_set_vadjustment (GTK_TREE_VIEW (widget),
                                 gtk_scrolled_window_get_vadjustment
                                 (GTK_SCROLLED_WINDOW (sw)));

  gtk_container_set_focus_hadjustment (GTK_CONTAINER (widget),
                                       gtk_scrolled_window_get_hadjustment
                                       (GTK_SCROLLED_WINDOW (sw)));
  gtk_container_set_focus_vadjustment (GTK_CONTAINER (widget),
                                       gtk_scrolled_window_get_hadjustment
                                       (GTK_SCROLLED_WINDOW (sw)));
}

/* create gpeskwindow */
GtkWidget *
create_gpe_window (gchar *menu_left, gchar *menu_right, gchar *menu_left_str,
                   gchar *menu_right_str)
{
  GtkWidget *window;

  /* create application window */
  window = gpe_skwindow_new ();
  gtk_window_set_default_size (GTK_WINDOW (window), 240, 320);

  menus_create (window, menu_left, menu_right);

  /* install global key handler */
  g_signal_connect (G_OBJECT (window), "softkey_activated",
                    G_CALLBACK (softkey_activated), window);
  
  /* set up softkey usage */
  setup_softkeys (window, menu_left_str, menu_right_str);

  return window;
}


/* Call activated if a softkey is pressed. */
void
softkey_activated (GtkWidget *widget, gint key_number, gpointer data)
{
  const gchar *label = NULL;
  GtkWidget *window = NULL;

  /* handle non-popup softkey events here */
  if (key_number == SK_LEFT)
  {
    label = gpe_skwindow_get_softkey_label (GPE_SKWINDOW (widget), SK_LEFT);

    if (strcmp (label, "OK") == 0)
    {
      switch (count)
      {
        case 0:
          choose_msg (NULL, NULL, NULL, NULL);
          break;
        case 1:
          choose_sms (NULL, NULL, NULL, NULL);
          break;
        default:
          break;
      }
      return;
    }

    if (strcmp (label, "PhoneBook") == 0)
    {
      {
        if (sms_iac_abook ())
          g_print ("go to abook service!\n");
      }

    }
    else if (strcmp (label, "Options") == 0)
    {
      label = gpe_skwindow_get_softkey_label (GPE_SKWINDOW (widget), SK_RIGHT);
      gpe_skwindow_set_softkey_label (GPE_SKWINDOW (widget), SK_RIGHT,
                                      "Cancel");
      gpe_skwindow_set_softkey_label (GPE_SKWINDOW (widget), SK_LEFT, "OK");
    }
  }

  if (key_number == SK_RIGHT)
  {
    if (sms_flag.start_from_abook_flag)
    {

      app_msg_quit ();
    }
    else if (sms_flag.dbus_invoke_flag)
    {

      destroy_current_window (widget);
      sms_flag.dbus_invoke_flag = FALSE;
    }
    else
    {
      if (msgtest.garray != NULL)
      {
        g_print ("%d\n", msgtest.garray->len);
        g_array_free (msgtest.garray, TRUE);      /* free invalid pointer */
        msgtest.garray = NULL;
      }

      destroy_current_window (widget);


      if (sms_flag.create_flag)
      {

        msg_sms_free_list (contact_from_addrbook);
        contact_from_addrbook = NULL;
        sms_flag.create_flag = FALSE;

      }

      if (count < 0)
        app_msg_quit ();

      else
      {
        window = get_current_window ();
        gtk_window_present (GTK_WINDOW (window));

        if ((count == MSG_SMS_CREATE_OR_FOLDERLIST
             || count == MSG_SMS_VIEW_FROM_FOLDER))
          gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), SK_LEFT,
                                          "Options");


        if (count == MSG_SMS_FOLDERS)
        {
          gtk_list_store_clear (sms_treeview.folder_list_store);
          get_folders (sms_treeview.folder_list_store);
          sms_treeview.sms_list_store = NULL;
          set_tree_view_cursor (sms_treeview.folder_list_tree_view,
                                sms_path.folder_path);
        }
        if (sms_flag.view_new_flag)
          time_out_id = g_timeout_add (1, (GSourceFunc) reload_inbox, window);
      }
    }
  }
}

gboolean
reload_inbox ()
{

  if (time_out_id != 0)
    g_source_remove (time_out_id);

  if (sms_treeview.sms_list_store)
  {
    refresh_smses_from_folder (sms_treeview.sms_list_store, msgtest.fid);
    set_tree_view_cursor (sms_treeview.sms_list_tree_view,
                          sms_path.sms_list_path);
  }
  gtk_list_store_clear (sms_treeview.folder_list_store);
  get_folders (sms_treeview.folder_list_store);
  set_tree_view_cursor (sms_treeview.folder_list_tree_view,
                        sms_path.folder_path);

  sms_flag.view_new_flag = FALSE;

  return FALSE;

}

void
service_close ()
{

  msg_evt_unregister (1, 2);
  msg_evt_unregister (1, 3);
  msg_evt_unregister (1, 1);
  msg_evt_unregister (1, 4);
  msg_service_close ();

  if (loop)
  {
    g_main_loop_quit (loop);
    g_main_loop_unref (loop);
    loop = NULL;
  }
  return;
}

void
msg_sms_free_list (GList *list)
{
  if (list)
  {
    gint i;

    g_print ("list size1111:%d\n", g_list_length (list));
    for (i = 0; i < g_list_length (list); i++)
    {
      g_free (g_list_nth_data (list, i));
    }
    g_list_free (list);
    pre_list_count = 0;

  }

}

void
msg_sms_free_hashtable (GHashTable *hash_table)
{
  if (hash_table != NULL)
    g_hash_table_destroy (hash_table);
}

gint
get_current_count ()
{
  return count;
}

void
app_msg_quit (void)
{
  if (service_start == 1)
  {
    service_close ();
    service_start = 0;
  }
  msg_sms_free_list (contact_from_addrbook);
  contact_from_addrbook = NULL;
  msg_sms_free_hashtable (hashtable);
  hashtable = NULL;

  sms_treeview.folder_list_store = NULL;
  sms_treeview.folder_list_tree_view = NULL;
  sms_treeview.sms_list_store = NULL;
  sms_treeview.sms_list_tree_view = NULL;

  sms_path.folder_path = NULL;
  sms_path.sms_list_path = NULL;

  textview.buffer_contact = NULL;
  textview.buffer_content = NULL;

  sms_iac_finalize ();
  gtk_main_quit ();
}

void
get_icon_by_status (GdkPixbuf **icon, msg_status_t status)
{

  if (status == MSG_RECEIVED_UNREAD)
    *icon = get_icon ("msg_icon_unread.png");

  else if (status == MSG_RECEIVED_REPLIED)
    *icon = get_icon ("msg_icon_replied.png");

  else
    *icon = get_icon ("msg_icon_read.png");

}

void
get_contacts_from_addrbook (void)
{
  gchar *insert_name = NULL;
  gint j;

  while (pre_list_count < g_list_length (contact_from_addrbook))
  {
    insert_name =
      (gchar *) g_list_nth_data (contact_from_addrbook, pre_list_count);
    gtk_text_buffer_insert_at_cursor (textview.buffer_contact, insert_name, -1);

    gtk_text_buffer_insert_at_cursor (textview.buffer_contact, "; ", -1);
    pre_list_count = pre_list_count + 2;
  }
}

gboolean
search_from_addressbook (gint index, const gchar *num, gchar **name_b,
                         gchar **photo_path_b)
{
  return search_name_from_ab (num, name_b, photo_path_b, NULL);
}

GtkWidget *
get_current_window (void)
{
  GtkWidget *window = NULL;

  window = GTK_WIDGET (g_hash_table_lookup (hashtable, &array[count]));

  return window;
}

void
destroy_current_window (GtkWidget *window)
{
  gtk_widget_destroy (window);
  g_hash_table_remove (hashtable, &array[count]);
  count--;
}

static gboolean
search_name_from_sim (gint index, const gchar *num, gchar **name_b,
                      gchar **photo_path_b, gchar **Ringtone_path_b)
{
  ab_contact_t *temp = NULL;
  ab_contact_t *result = NULL;
  ab_uuid_t **uids = NULL;
  ab_sid_t sid;
  ab_err_t err;
  gint i;
  gint databaseid = 0;

  if (!uids)
  {
    ab_disconnect (sid);
    err = ab_connect (index, &sid);
    if (err != AB_ERROR_NONE)
    {
      g_print ("%s(): connecting to %d failed.\n", __FUNCTION__, 0);
      pim_quit ();
      return EXIT_FAILURE;
    }
    ab_create_contact (sid, &temp);
    ab_contact_set_field (temp, 5, num);
    uids = ab_get_contact_ids (sid, temp);
    ab_contact_free (temp);

    if (!uids)
    {
      ab_create_contact (sid, &temp);
      if (strstr (num, "+86"))
      {
        ab_contact_set_field (temp, 5, num + 3);
      }
      else
      {
        gchar *num_temp = g_strdup_printf ("+86%s", num);

        ab_contact_set_field (temp, 5, num);
        g_free (num_temp);
      }
      uids = ab_get_contact_ids (sid, temp);
      ab_contact_free (temp);
    }
  }

  if (uids)
  {
    for (i = 0; uids[i] != NULL; i++)
    {
      gchar *name;

      ab_get_contact (sid, *uids[0], &result);
      ab_contact_get_field (result, 4, (void *) &name);
      if (photo_path_b)
        *photo_path_b =
          g_strdup_printf ("%s/pixmaps/%s", ABOOK_DATA_PATH, "iconsim.png");
      if (name_b)
        *name_b = g_strdup (name);
      if (Ringtone_path_b)
        *Ringtone_path_b = g_strdup_printf ("%s/%s", ABOOK_DATA_PATH, "");
      ab_contact_free (result);
      break;
    }

    for (i = 0; uids[i] != NULL; i++)
    {
      g_free (uids[i]);
    }

    g_free (uids);
  }

  return EXIT_SUCCESS;
}

gboolean
search_name_from_ab (const gchar *num, gchar **name_b, gchar **photo_path_b,
                     gchar **Ringtone_path_b)
{
  ab_contact_t *temp = NULL;
  ab_contact_t *result = NULL;
  ab_uuid_t **uids = NULL;
  ab_sid_t sid;
  ab_err_t err;
  gint i;
  gint databaseid = 0;

  if (!uids)
  {
    databaseid = 0;
    err = ab_connect (databaseid, &sid);
    if (err != AB_ERROR_NONE)
    {
      g_print ("%s(): connecting to %d failed.\n", __FUNCTION__, 0);
      pim_quit ();
      return EXIT_FAILURE;
    }
    int field = 3;

    for (; field < 7; field++)
    {
      ab_create_contact (sid, &temp);
      ab_contact_set_field (temp, field, num);
      uids = ab_get_contact_ids (sid, temp);
      if (uids)
      {
        ab_contact_free (temp);
        break;
      }
      ab_contact_free (temp);
      ab_create_contact (sid, &temp);

      if (strstr (num, "+86"))
      {
        ab_contact_set_field (temp, field, num + 3);
      }
      else
      {
        gchar *num_temp = g_strdup_printf ("+86%s", num);

        ab_contact_set_field (temp, field, num_temp);
        g_free (num_temp);
      }
      
      uids = ab_get_contact_ids (sid, temp);
      if (uids)
      {
        ab_contact_free (temp);
        break;
      }
    }
  }

  if (!uids)
  {
    databaseid = 1;
    ab_disconnect (sid);
    err = ab_connect (databaseid, &sid);
    if (err != AB_ERROR_NONE)
    {
      g_print ("%s(): connecting to %d failed.\n", __FUNCTION__, 0);
      pim_quit ();
      return EXIT_FAILURE;
    }
    ab_create_contact (sid, &temp);
    ab_contact_set_field (temp, 5, num);
    uids = ab_get_contact_ids (sid, temp);
    ab_contact_free (temp);

    if (!uids)
    {


      ab_create_contact (sid, &temp);
      if (strstr (num, "+86"))
      {
        ab_contact_set_field (temp, 5, num + 3);
      }
      else
      {
        gchar *num_temp = g_strdup_printf ("+86%s", num);

        ab_contact_set_field (temp, 5, num);
        g_free (num_temp);
      }
      uids = ab_get_contact_ids (sid, temp);
      ab_contact_free (temp);
    }
  }

  if (uids)
  {
    if (databaseid == 0)
    {
      for (i = 0; uids[i] != NULL; i++)
      {
        gchar *name, *photo_path_t, *Ringtone_path;

        ab_get_contact (sid, *uids[0], &result);
        ab_contact_get_field (result, 2, (void *) &name);
        ab_contact_get_field (result, 11, (void *) &photo_path_t);
        ab_contact_get_field (result, 11, (void *) &Ringtone_path);

        if (photo_path_b)
          *photo_path_b =
            g_strdup_printf ("%s/pixmaps/%s", ABOOK_DATA_PATH, photo_path_t);
        if (name_b)
          *name_b = g_strdup (name);
        if (Ringtone_path_b)
          *Ringtone_path_b =
            g_strdup_printf ("%s/%s", ABOOK_DATA_PATH, photo_path_t);
        ab_contact_free (result);
        break;
      }
    }
    else
    {
      for (i = 0; uids[i] != NULL; i++)
      {
        gchar *name;

        ab_get_contact (sid, *uids[0], &result);
        ab_contact_get_field (result, 4, (void *) &name);
        if (photo_path_b)
          *photo_path_b =
            g_strdup_printf ("%s/pixmaps/%s", ABOOK_DATA_PATH, "iconsim.png");
        if (name_b)
          *name_b = g_strdup (name);
        if (Ringtone_path_b)
          *Ringtone_path_b = g_strdup_printf ("%s/%s", ABOOK_DATA_PATH, "");
        ab_contact_free (result);
        break;
      }
    }

    for (i = 0; uids[i] != NULL; i++)
    {
      g_free (uids[i]);
    }

    g_free (uids);
  }
  else
  {
    if (photo_path_b)
      *photo_path_b = NULL;
    if (name_b)
      *name_b = NULL;
    if (Ringtone_path_b)
      *Ringtone_path_b = NULL;
  }

  ab_disconnect (sid);

  return TRUE;
}

