/*	sms - application for sending, receiving and management of short message
 *
 *	Authors: YIN Huasong, WU Yu <yu.wu@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#include <stdint.h>
#include <string.h>
#include <glib.h>

#include <message.h>

extern int _index_file_init(char *prefix, uint32_t number);

int
add_system_folder (char *label, uint32_t fid)
{
  msg_folder_t *folder = NULL;

  folder = test_system_folder_new (fid, label);

  msg_folder_add_child (1, 0, folder);

  msg_folder_release (1, folder);

  return 0;

}

int
system_contruct ()
{

  add_system_folder ("ROOT", 0);
  printf ("ROOT folder added\n");
  add_system_folder ("INBOX", 7);
  printf ("INBOX added\n");
  add_system_folder ("OUTBOX", 8);
  printf ("OUTBOX added\n");
  add_system_folder ("SENT", 9);
  printf ("SENT folder added\n");
  add_system_folder ("TEMPLATE", 15);
  printf ("TEMPLATE folder added\n");
  add_system_folder ("DRAFT", 10);
  printf ("DRAFT folder added\n");

  _index_file_init ("conf/folder_id_index", 20);
  _index_file_init ("conf/msg_id_index", 0);

  printf ("id index init\n");


  return 0;

}


int
main (int argc, char *argv[])
{

	system_contruct ();
  return 0;

}

